package com.github.kittinunf.fuel.android

import com.github.kittinunf.fuel.test.MockHelper
import org.junit.After
import org.junit.Before
import org.junit.runner.RunWith
import org.robolectric.RobolectricTestRunner
import org.robolectric.annotation.Config
import java.util.concurrent.CountDownLatch
import java.util.concurrent.TimeUnit

@RunWith(RobolectricTestRunner::class)
@Config(constants = BuildConfig::class, sdk = [26])
abstract class BaseTestCase {

    companion object {
        private const val DEFAULT_TIMEOUT = 15L
    }

    protected lateinit var mock: MockHelper
    lateinit var lock: CountDownLatch

    fun await(seconds: Long = DEFAULT_TIMEOUT) {
        lock.await(seconds, TimeUnit.SECONDS)
    }

    @Before
    fun setup() {
        this.mock = MockHelper()
        this.mock.setup()
    }

    @After
    fun breakdown() {
        this.mock.tearDown()
    }
}
